package sun.security.util;

import java.util.Arrays;
import java.util.Collection;
import java.util.HashSet;
import java.util.Set;
import java.util.regex.Pattern;

public class AlgorithmDecomposer
{
    private static final Pattern transPattern;
    private static final Pattern pattern;
    
    public AlgorithmDecomposer() {
    }
    
    private static Set<String> decomposeImpl(String input) {
        String[] split = AlgorithmDecomposer.transPattern.split(input);
        HashSet<String> set = new HashSet();
        for (String input2 : split) {
            if (input2 != null && input2.length() != 0) {
                String[] split2;
                for (String s : split2 = AlgorithmDecomposer.pattern.split(input2)) {
                    if (s != null && s.length() != 0) {
                        set.add(s);
                    }
                }
            }
        }
        return set;
    }
    
    public Set<String> decompose(String s) {
        if (s == null || s.length() == 0) {
            return new HashSet();
        }
        Set<String> decomposeImpl = decomposeImpl(s);
        if (decomposeImpl.contains("SHA1") && !decomposeImpl.contains("SHA-1")) {
            decomposeImpl.add("SHA-1");
        }
        if (decomposeImpl.contains("SHA-1") && !decomposeImpl.contains("SHA1")) {
            decomposeImpl.add("SHA1");
        }
        if (decomposeImpl.contains("SHA224") && !decomposeImpl.contains("SHA-224")) {
            decomposeImpl.add("SHA-224");
        }
        if (decomposeImpl.contains("SHA-224") && !decomposeImpl.contains("SHA224")) {
            decomposeImpl.add("SHA224");
        }
        if (decomposeImpl.contains("SHA256") && !decomposeImpl.contains("SHA-256")) {
            decomposeImpl.add("SHA-256");
        }
        if (decomposeImpl.contains("SHA-256") && !decomposeImpl.contains("SHA256")) {
            decomposeImpl.add("SHA256");
        }
        if (decomposeImpl.contains("SHA384") && !decomposeImpl.contains("SHA-384")) {
            decomposeImpl.add("SHA-384");
        }
        if (decomposeImpl.contains("SHA-384") && !decomposeImpl.contains("SHA384")) {
            decomposeImpl.add("SHA384");
        }
        if (decomposeImpl.contains("SHA512") && !decomposeImpl.contains("SHA-512")) {
            decomposeImpl.add("SHA-512");
        }
        if (decomposeImpl.contains("SHA-512") && !decomposeImpl.contains("SHA512")) {
            decomposeImpl.add("SHA512");
            return decomposeImpl;
        }
        return decomposeImpl;
    }
    
    public static Collection<String> getAliases(String s) {
        String[] a;
        if (s.equalsIgnoreCase("DH") || s.equalsIgnoreCase("DiffieHellman")) {
            a = new String[] { "DH", "DiffieHellman" };
        }
        else {
            a = new String[] { s };
        }
        return Arrays.asList(a);
    }
    
    private static void hasLoop(Set<String> set, String s, String s2) {
        if (set.contains(s)) {
            if (!set.contains(s2)) {
                set.add(s2);
            }
            set.remove(s);
        }
    }
    
    public static Set<String> decomposeOneHash(String s) {
        if (s == null || s.length() == 0) {
            return new HashSet();
        }
        Set<String> decomposeImpl = decomposeImpl(s);
        hasLoop(decomposeImpl, "SHA-1", "SHA1");
        hasLoop(decomposeImpl, "SHA-224", "SHA224");
        hasLoop(decomposeImpl, "SHA-256", "SHA256");
        hasLoop(decomposeImpl, "SHA-384", "SHA384");
        hasLoop(decomposeImpl, "SHA-512", "SHA512");
        return decomposeImpl;
    }
    
    public static String hashName(String s) {
        return s.replace("-", "");
    }
    
    static {
        transPattern = Pattern.compile("/");
        pattern = Pattern.compile("with|and", 2);
    }
}
